FUNCTION FIND_EXTREMUM, MAXIMUM = MAXIMUM, $   
                        MINIMUM = MINIMUM, $  
                        PATH = path                           
   
answer = 0  
  
file = PICKFILE(TITLE='Open File',$                   ; Get name of data-file      
                     FILTER='*.sav',$      
                      PATH=path,$      
                       GET_PATH=path)      
  
IF file EQ '' THEN RETURN, 0                           ; 'Cancel' was pressed      
  
 
RESTORE,file       
       
 
IF NOT DEFINED(im) THEN BEGIN       
       
       IF NOT DEFINED(data) THEN BEGIN       
          mess=WIDGET_MESSAGE('No data!',/ERROR)       
          RETURN,0   
       ENDIF       
   
   
       IF KEYWORD_SET(MAXIMUM) THEN BEGIN   
             
          extremum = MAX ( data )   
       
          searchtype = 'maximum'   
   
       ENDIF ELSE BEGIN   
             
          extremum = MIN ( data )       
   
          searchtype = 'minimum'   
   
       ENDELSE   
   
        
       result = WHERE ( data EQ extremum )   
          
       tmp = WIDGET_MESSAGE([['Press Ok to choose'], $ 
                             ['the result file']], $      
                            /INFORMATION )      
         
       orifile = file      
         
       file = PICKFILE(/WRITE, $      
               PATH=path, $      
               FILE=path+STRTRUNC(FPRAEFIX(file,/NO_PATH),5,0)+'.txt', $      
               FILTER='*.txt',$      
               GET_PATH=path)      
      
       IF file EQ '' THEN RETURN, 0                 ; 'Cancel' was pressed      
         
       IF N_ELEMENTS(data(*,*,0,*)) EQ N_ELEMENTS(epoches) THEN BEGIN       
       
             OPENW,unit,file,/GET_LUN       
             PRINTF,unit,'Results for ' + searchtype + ' search:'       
             PRINTF,unit,'==========================='       
             PRINTF,unit,'File:            ', orifile       
             PRINTF,unit,'Mode: Point mode'       
             PRINTF,unit,'Longitude [deg]: ',STRTRIM(STRING(lon(0)),1)       
             PRINTF,unit,'Latitude [deg]:  ',STRTRIM(STRING(lat(0)),1)       
             PRINTF,unit,'Depth [m]:       ',STRTRIM(STRING(MIN(z)),1)       
             PRINTF,unit,'Min. epoche :               ',dt_tm_fromjs(t(0),FORMAT='0d$.n$.Y$ h$:m$:s$')       
             PRINTF,unit,'Max. epoche :               ',dt_tm_fromjs(t(1),FORMAT='0d$.n$.Y$ h$:m$:s$')       
             PRINTF,unit,'Time window:                ',strsec(timewin)       
             PRINTF,unit,'Time shift:                 ',strsec(shift)       
             PRINTF,unit       
             PRINTF,unit, searchtype + ' found at:'       
             epoche = result - FLOOR( result / N_ELEMENTS(epoches) ) * N_ELEMENTS(epoches)       
             epoche = FLOOR( epoche ) * shift + t(0)       
             PRINTF,unit,'Epoche :          ',dt_tm_fromjs(epoche,FORMAT='0d$.n$.Y$ h$:m$:s$')       
             PRINTF,unit,'Value : ',STRTRIM ( STRING( extremum ) , 1 )       
       
       ENDIF ELSE BEGIN       
       
             OPENW,unit,file,/GET_LUN       
             PRINTF,unit,'Results for ' + searchtype + ' extremum search:'       
             PRINTF,unit,'==========================='       
             PRINTF,unit,'File:                       ', orifile       
             PRINTF,unit,'Mode: Grid mode'       
             PRINTF,unit,'Min./ max. longitude [deg]: ',STRTRIM(STRING(lon(0)),1),' / ',STRTRIM(STRING(lon(1)),1)       
             PRINTF,unit,'Min./ max. latitude [deg]:  ',STRTRIM(STRING(lat(0)),1),' / ',STRTRIM(STRING(lat(1)),1)       
             PRINTF,unit,'Min./ max. depth [m]:       ',STRTRIM(STRING(MIN(z)),1),' / ',STRTRIM(STRING(MAX(z)),1)       
             PRINTF,unit,'Grid-spacing [deg]:         ',STRTRIM(STRING(spacing),1)       
             PRINTF,unit,'Depth-spacing [m]:          ',STRTRIM(STRING(z_spacing),1)       
             PRINTF,unit,'Min. epoche :               ',dt_tm_fromjs(t(0),FORMAT='0d$.n$.Y$ h$:m$:s$')       
             PRINTF,unit,'Max. epoche :               ',dt_tm_fromjs(t(1),FORMAT='0d$.n$.Y$ h$:m$:s$')       
             PRINTF,unit,'Time window:                ',strsec(timewin)       
             PRINTF,unit,'Time shift:                 ',strsec(shift)       
             PRINTF,unit       
             PRINTF,unit, searchtype + ' found at:'       
             longitude = result - FLOOR( result / n_lon ) * n_lon       
             longitude = longitude * spacing + lon(0)       
             longitude = STRTRIM ( STRING( longitude ), 1 )       
             PRINTF,unit,'Longitude [deg]:  ', longitude       
             latitude = result - FLOOR( result / ( n_lat * n_lon ) ) * n_lon * n_lat       
             latitude = FLOOR( latitude / n_lon ) * spacing + lat(0)       
             latitude = STRTRIM ( STRING( latitude ) , 1 )       
             PRINTF,unit,'Latitude [deg]:   ', latitude       
             depth = result - FLOOR( result / ( n_lat * n_lon * n_z ) ) * n_lat * n_lon * n_z       
             depth = FLOOR( depth / ( n_lon * n_lat ) ) * z_spacing + z(0)       
             depth = STRTRIM ( STRING( depth ) , 1 )       
             PRINTF,unit,'Depth [m]:        ', depth       
             epoche = result - FLOOR( result / ( n_lat * n_lon * n_z * N_ELEMENTS(epoches) ) ) * n_lon * n_lat * n_z * N_ELEMENTS(epoches)       
             epoche = FLOOR( epoche / ( n_lat * n_lon * n_z) ) * shift + t(0)       
             PRINTF,unit,'Epoche :          ',dt_tm_fromjs(epoche,FORMAT='0d$.n$.Y$ h$:m$:s$')       
             PRINTF,unit,'Value : ',STRTRIM ( STRING( extremum ) , 1 )       
       
       ENDELSE       
       
       FREE_LUN,unit       
   
       answer = 1  
         
       yn = XDECISION('Do You want to see the results now ?')      
       IF STRUPCASE(yn) EQ 'Y' THEN XDISPLAYFILE, file      
      
ENDIF 
  
  
   
RETURN, answer   
   
END   
   
   
