;-------------------------------------------------------------
;+
; NAME:
;       MORE_SPATIAL
; PURPOSE:
;       This routine creates a widget interface for editing the spatial window for SEISMOLAP
;       Subroutine for SLAP
;       SEISMOLAP was developed by Jochen Zschau,
;       Geoforschungszentrum Potsdam, Germany
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TU-Darmstadt, Germany, 17 Apr, 1998.
;       No warranty that this program is free of error
;
;-
;-------------------------------------------------------------
PRO MORE_SPATIAL,$
            INITIALIZE=INITIALIZE,$
            ALTERED=altered,$
            SWITCH_KEYBOARD=switch_keyboard,$
            SWITCH_MOUSE=switch_mouse,$
            SWITCH_POINT_MODE=switch_point_mode,$
            SWITCH_DEPTH_RANGE=switch_depth_range,$
            SWITCH_QUAKE_NE_GRID=switch_quake_ne_grid,$
            SWITCH_NORMALIZE=switch_normalize,$
            SWITCH_QUIESCENCE=switch_quiescence,$
            SWITCH_ERROR=switch_error

  IF KEYWORD_SET(INITIALIZE) THEN BEGIN

     switch_quake_ne_grid=0
     switch_point_mode=0
     switch_depth_range=0
     switch_keyboard=0
     switch_mouse=1
     switch_normalize=1
     switch_quiescence=0
     switch_error=0

     RETURN

  ENDIF

  switch_point_mode_old=switch_point_mode
  switch_depth_range_old=switch_depth_range
  switch_quake_ne_grid_old=switch_quake_ne_grid
  switch_keyboard_old=switch_keyboard
  switch_mouse_old=switch_mouse
  switch_normalize_old=switch_normalize
  switch_quiescence_old=switch_quiescence
  switch_error_old=switch_error
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }

  MAIN1 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='More Settings', $
      UVALUE='MAIN1')

  BASE13 = WIDGET_BASE(MAIN1, $
      COLUMN=1, $
      FRAME=1, $
      MAP=1, $
      UVALUE='BASE13')

  LABEL19 = WIDGET_LABEL( BASE13, $
      UVALUE='LABEL19', $
      VALUE='Grid settings')

  Btns5181 = [ $
    'Keyboard', $
    'Mouse' ]
  BGROUP_SWITCH_SET_COORD = CW_BGROUP( BASE13, Btns5181, $
      COLUMN=1, $
      /NO_RELEASE,$
      EXCLUSIVE=1, $
      UVALUE='BGROUP_SWITCH_SET_COORD')

  Btns5183 = [ $
    'Point mode' ]
  BGROUP_SWITCH_POINT_MODE = CW_BGROUP( BASE13, Btns5183, $
      COLUMN=1, $
      NONEXCLUSIVE=1, $
      UVALUE='BGROUP_SWITCH_POINT_MODE')

  BASE48 = WIDGET_BASE(BASE13, $
      COLUMN=1, $
      MAP=1, $
      UVALUE='BASE48')

  Btns5187 = [ $
    'Allow depth ranging' ]
  BGROUP_SWITCH_DEP_RANGE = CW_BGROUP( BASE48, Btns5187, $
      ROW=1, $
      NONEXCLUSIVE=1, $
      UVALUE='BGROUP_SWITCH_DEP_RANGE')


  BASE29 = WIDGET_BASE(MAIN1, $
      COLUMN=1, $
      FRAME=1, $
      MAP=1, $
      UVALUE='BASE29')

  LABEL34 = WIDGET_LABEL( BASE29, $
      UVALUE='LABEL34', $
      VALUE='Quake settings')

  Btns5191 = [ $
    'Allow other length as gridcube' ]
  BGROUP_SWITCH_QUAKE_NE_GRID = CW_BGROUP( BASE29, Btns5191, $
      COLUMN=1, $
      NONEXCLUSIVE=1, $
      UVALUE='BGROUP_SWITCH_QUAKE_NE_GRID')

  BASE67 = WIDGET_BASE(MAIN1, $
      COLUMN=1, $
      FRAME=1, $
      MAP=1, $
      UVALUE='BASE67')

  LABEL65 = WIDGET_LABEL( BASE67, $
      UVALUE='LABEL65', $
      VALUE='Results')

  Btns890 = [ $
    'Normalize SEISMOLAP - values' ]
  BGROUP_SWITCH_NORMALIZE = CW_BGROUP( BASE67, Btns890, $
      COLUMN=1, $
      NONEXCLUSIVE=1, $
      UVALUE='BGROUP_SWITCH_NORMALIZE')

  Btns637 = [ $
    'Compute Quiescence' ]
  BGROUP_SWITCH_QUIESCENCE = CW_BGROUP( BASE67, Btns637, $
      COLUMN=1, $
      NONEXCLUSIVE=1, $
      UVALUE='BGROUP_SWITCH_QUIESCENCE')

  Btns660 = [ $
    'Compute error' ]
  BGROUP_SWITCH_ERROR = CW_BGROUP( BASE67, Btns660, $
      COLUMN=1, $
      NONEXCLUSIVE=1, $
      UVALUE='BGROUP_SWITCH_ERROR')

  LABEL36 = WIDGET_LABEL( MAIN1, $
      UVALUE='LABEL36', $
      VALUE='')

  BUTTON_CANCEL = WIDGET_BUTTON( MAIN1, $
      UVALUE='BUTTON_CANCEL', $
      VALUE='Cancel')

  BUTTON_OK = WIDGET_BUTTON( MAIN1, $
      UVALUE='BUTTON_OK', $
      VALUE='Ok')

  WIDGET_CONTROL,BGROUP_SWITCH_QUAKE_NE_GRID,SET_VALUE=switch_quake_ne_grid
  tmp=WHERE([switch_keyboard,switch_mouse])
  WIDGET_CONTROL,BGROUP_SWITCH_SET_COORD,SET_VALUE=tmp(0)
  WIDGET_CONTROL,BGROUP_SWITCH_DEP_RANGE,SET_VALUE=switch_depth_range
  WIDGET_CONTROL,BGROUP_SWITCH_POINT_MODE,SET_VALUE=switch_point_mode
  CASE switch_point_mode OF
      0: BEGIN
         END
      1: BEGIN
         WIDGET_CONTROL,BASE48, SENSITIVE=0
         END
  ENDCASE
  WIDGET_CONTROL,BGROUP_SWITCH_NORMALIZE,SET_VALUE=switch_normalize
  WIDGET_CONTROL,BGROUP_SWITCH_QUIESCENCE,SET_VALUE=switch_quiescence
  WIDGET_CONTROL,BGROUP_SWITCH_ERROR,SET_VALUE=switch_error

  WIDGET_CONTROL, MAIN1, /REALIZE

  Ev=''

  WHILE (Ev NE 'BUTTON_OK') AND (Ev NE 'BUTTON_CANCEL') DO BEGIN

  Event=WIDGET_EVENT(MAIN1)

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF

  'BGROUP_SWITCH_SET_COORD': BEGIN

      CASE Event.Value OF
      0: BEGIN
          switch_keyboard=1
          switch_mouse=0
         END
      1: BEGIN
         switch_keyboard=0
         switch_mouse=1

         END
      ENDCASE

      altered=1

      END

  'BGROUP_SWITCH_POINT_MODE': BEGIN

      switch_point_mode = Event.Select

      CASE switch_point_mode OF
      0: BEGIN
         WIDGET_CONTROL,BASE48, /SENSITIVE

         END
      1: BEGIN
         WIDGET_CONTROL,BASE48, SENSITIVE=0

         switch_depth_range=0
         WIDGET_CONTROL,BGROUP_SWITCH_DEP_RANGE,SET_VALUE=switch_depth_range

         END
      ENDCASE
      altered=1

      END

  'BGROUP_SWITCH_DEP_RANGE': BEGIN
      switch_depth_range=Event.Select
      altered=1
      IF switch_depth_range THEN BEGIN
         mess=WIDGET_MESSAGE([['Note that this setting can lead to'], $
                             ['very high processing time and memory consumption']] )

      ENDIF
      END
  'BGROUP_SWITCH_QUAKE_NE_GRID': BEGIN
      switch_quake_ne_grid=Event.Select
      IF switch_quake_ne_grid THEN BEGIN
         mess=WIDGET_MESSAGE('Note that this method is not SEISMOLAP-conform')

      ENDIF
      altered=1
      END

  'BGROUP_SWITCH_NORMALIZE': BEGIN
      switch_normalize=Event.Select
      altered=1
      END

  'BGROUP_SWITCH_QUIESCENCE': BEGIN
      switch_quiescence=Event.Select
      altered=1
      END

  'BGROUP_SWITCH_ERROR': BEGIN
      switch_error=Event.Select
      altered=1
      END

  'BUTTON_CANCEL': BEGIN
      END

  'BUTTON_OK': BEGIN
      END
  ENDCASE

  ENDWHILE

IF Ev EQ 'BUTTON_CANCEL' THEN BEGIN

      ;Restoring initial values

      switch_point_mode=switch_point_mode_old
      switch_depth_range=switch_depth_range_old
      switch_quake_ne_grid=switch_quake_ne_grid_old
      switch_keyboard=switch_keyboard_old
      switch_mouse=switch_mouse_old
      switch_error=switch_error_old
      switch_normalize=switch_normalize_old
      switch_quiescence=switch_quiescence_old

ENDIF

IF DEFINED(MAIN1) THEN WIDGET_CONTROL,MAIN1,/DESTROY

END
