;-------------------------------------------------------------
;+
; NAME:
;       XNOTE
; PURPOSE:
;       Pops up a window with informational text.
;       Blocks until OK - Button is pressed.
; MODIFICATION HISTORY:
;       Matthias Liebetanz, 15. Apr, 1997
;-
;-------------------------------------------------------------
FUNCTION XNOTE, text, ERROR=ERROR, WARNING=WARNING, INFORMATION=INFORMATION

      IF NOT ( KEYWORD_SET(ERROR) OR KEYWORD_SET(ERROR) ) THEN title = 'Warning'
      IF KEYWORD_SET(ERROR) THEN title = 'Error'
      IF KEYWORD_SET(INFORMATION) THEN title = 'Information'

      main=WIDGET_BASE(TITLE=title, $
                        /COLUMN, $
                        MAP=1)

      FOR i=0,N_ELEMENTS(text)-1 DO BEGIN
          question = WIDGET_LABEL( main,$
                                   VALUE=text(i))
      ENDFOR

      CASE !VERSION.OS OF

           'windows':   child=WIDGET_BASE(main,$  ;IDL 3.6 for windows
                        /ROW)

           ELSE: child=WIDGET_BASE(main,$
                        /ROW,$
                        /ALIGN_CENTER)
      ENDCASE

      ok = WIDGET_BUTTON( child, $
          UVALUE='OK', $
          VALUE='Ok')

      answer = ''                                           ; Construct a state variable for this instance.

      WIDGET_CONTROL, WIDGET_INFO(main, /CHILD), $
                        SET_UVALUE=answer, /NO_COPY         ; Save the state in the first child's user value.

      WIDGET_CONTROL,main,/REALIZE
      WIDGET_CONTROL,ok,/INPUT_FOCUS

      pressed=WIDGET_EVENT(main)                           ; Look for arrived events

      WIDGET_CONTROL,pressed.id,GET_UVALUE=answer

      WIDGET_CONTROL, main,  /DESTROY                      ; Destroy application

      RETURN,answer
END




