;-------------------------------------------------------------
;+
; NAME:
;       XSELECTZ
; PURPOSE:
;       User interface to select a depth-slice
; MAIN PROGRAM:
;       SLAP - program for testing SEISMOLAP
;       SEISMOLAP was developed by Jochen Zschau,
;       Geoforschungszentrum Potsdam, Germany
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TH-Darmstadt, Germany, 17. Apr 1998 .
;
;       No warranty that this program is free of error
;-
;-------------------------------------------------------------
 FUNCTION XSELECTZ, depths       
        
     BASE=WIDGET_BASE(/COLUMN)     
     LABEL=WIDGET_LABEL(BASE,VALUE='Select a depth (in [m])')     
     depths=STRTRIM(STRING(depths),1)     
       
     CASE !VERSION.OS OF     
     'windows': BEGIN  
         LIST = CW_BGROUP( BASE, depths, $                      
                  COLUMN=1, $                      
                  EXCLUSIVE=1, $                      
                  /NO_RELEASE, $  
                  UVALUE='LIST')  
         END                                        
  
     ELSE: LIST = DROPLIST(BASE, VALUE=depths, UVALUE='LIST')  
     ENDCASE  
   
     LABEL=WIDGET_LABEL(BASE,VALUE='')     
     CANCEL=WIDGET_BUTTON(BASE,VALUE='Cancel',UVALUE='CANCEL')     
     OK=WIDGET_BUTTON(BASE,VALUE='Ok',UVALUE='OK')     
     WIDGET_CONTROL,BASE,/REALIZE     
     ev=''     
     WHILE (ev NE 'CANCEL') AND (ev NE 'OK') DO BEGIN     
     
           event=WIDGET_EVENT(BASE)     
     
           WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev     
     
           CASE Ev OF     
     
           'LIST': BEGIN     
                   CASE !VERSION.OS OF     
                   'windows': BEGIN  
                                 _z = event.value  
                                 _depth =DOUBLE(depths(event.value))  
                              END                                        
  
           ELSE: BEGIN  
                   _depth = DOUBLE(depths(event.index))     
                   _z = event.index     
                 END     
           ENDCASE  
           END  
           'OK': BEGIN     
             IF NOT N_ELEMENTS(_depth) THEN BEGIN     
                mess=WIDGET_MESSAGE('A value must be choosen',/ERROR)     
                ev=''     
             ENDIF     
             END     
           'CANCEL': BEGIN     
             END     
     
           ENDCASE     
     ENDWHILE     
     
     IF (ev EQ 'OK') THEN BEGIN     
     
        depth = _depth     
     
        z = _z     
     
        result = [depth,z] 
 
     ENDIF ELSE BEGIN     
     
        WIDGET_CONTROL,BASE,/DESTROY     
     
        RETURN,0     
     
     ENDELSE     
     
     IF DEFINED(BASE) THEN WIDGET_CONTROL,BASE,/DESTROY     
   
RETURN, result 
   
END   
   
